unit CatList;

interface
uses App, Drivers, Objects, Menus, Dialogs, Views, MsgBox, tpString,
     Net, Password;

var
 R: TRect;

const
 hcCatList      = 100;
 hcCatChoose    = 101;
 hcPasswords    = 102;
 cmLogout       = 100;
 cmRefresh      = 101;
 cmSendMsg      = 102;
 cmCancelToggle = 103;
 cmSendMsgNow   = 104;
 cmToggle       = 105;
 cmSortByName   = 106;
 cmSortByConn   = 107;
 cmSortByStat   = 108;
 cmPasswords    = 109;
 cmBroadToCons  = 110;
 cmLoginStatus  = 111;
 cmDownServer   = 112;

 SortType       : word = cmSortByStat;
 LastMessage    : String = 'Hi!';

 Passwords      : PView = Nil;

type
 PDummyUser = ^TDummyUser;
 TDummyUser = object(TObject)
  loginname: PString;
  station: integer;
  connection: byte;
  selected: boolean;
  newuser: boolean;
  constructor Init(_Name: String; _Conn: Byte);
  destructor Done; virtual;
 end;

 PUserBox = ^TUserBox;
 TUserBox = object(TListBox)
  function GetText(Item: Integer; MaxLen: Integer): String; virtual;
 end;

 TDummyUsers = object(TSortedCollection)
  function Compare(key1, key2: pointer): integer; virtual;
 end;

 PCatList = ^TCatList;
 TCatList = object(TDialog)
  Users: TDummyUsers;
  List: PUserBox;
  constructor Init;
  procedure UpdateList; virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  procedure LogoutThisStuff(U: PDummyUser); virtual;
  procedure SendTheMessage; virtual;
  procedure ToggleUser; virtual;
  procedure ShowPasswords; virtual;
  procedure BroadcastToConsole; virtual;
  procedure LoginStatus; virtual;
  procedure DownServer; virtual;
  destructor Done; virtual;
 end;

implementation

function TDummyUsers.Compare(key1, key2: pointer): integer;
 var
  k1,k2: PDummyUser;
 begin
  K1:=Key1;
  K2:=Key2;
  if SortType=cmSortByStat then
   if K1^.Station<K2^.Station then Compare:=-1 else
   if K1^.Station>K2^.Station then Compare:=1 else
    if K1^.LoginName^<K2^.LoginName^ then Compare:=-1 else
    if K1^.LoginName^>K2^.LoginName^ then Compare:=1 else
     Compare:=-1 else
  if SortType=cmSortByConn then
   if K1^.Connection<K2^.Connection then Compare:=-1 else
   if K1^.Connection>K2^.Connection then Compare:=1 else
    if K1^.LoginName^<K2^.LoginName^ then Compare:=-1 else
    if K1^.LoginName^>K2^.LoginName^ then Compare:=1 else
     Compare:=-1 else
  if SortType=cmSortByName then
   if K1^.LoginName^<K2^.LoginName^ then Compare:=-1 else
   if K1^.LoginName^>K2^.LoginName^ then Compare:=1 else
    if K1^.Station<K2^.Station then Compare:=-1 else
    if K1^.Station>K2^.Station then Compare:=1 else
     if K1^.Connection<K2^.Connection then Compare:=-1 else
     if K1^.Connection>K2^.Connection then Compare:=1 else
      Compare:=-1;
 end;

constructor TDummyUser.Init;
 begin
  inherited Init;
  LoginName:=NewStr(_Name);
  Connection:=_Conn;
  Selected:=False;
  NewUser:=False;
 end;

destructor TDummyUser.Done;
 begin
  DisposeStr(LoginName);
  inherited Done;
 end;

constructor TCatList.Init;
 begin
  R.Assign(0,0,70,18);
  Inherited Init(R,'List');
  Users.Init(1,1);

  Options:=Options or ofCentered;

  R.Assign(2,2,Size.X-2,Size.Y-1);
  List:=New(PUserBox,Init(R,1,StandardScrollBar(sbVertical)));
  Insert(List);

  R.Assign(2,1,Size.X-2,2);
  Insert(New(PLabel,Init(R,'~U~sers                                     (~c~) by ~S~ergey ~K~orowkin',List)));

  UpdateList;

  HelpCtx:=hcCatList;

  DisableCommands([SortType]);
 end;

procedure TCatList.UpdateList;
 var
  C: Byte;
  UserInfo: ConnectInfoReply;
  U: PDummyUser;
  S: String;
  OldUsers: TCollection;
  D: TDialog;
  R: TRect;
 procedure MoveThis(A: PDummyUser); far;
  begin
   OldUsers.Insert(A);
  end;
 procedure CheckThis(A: PDummyUser); far;
  begin
   if (A=Nil) or (A^.LoginName=Nil) then Exit;
   if (A^.LoginName^=U^.LoginName^) and (A^.Connection=U^.Connection) then U^.NewUser:=False;
  end;
 procedure CheckThisStuff(A: PDummyUser);
  var
   F: Text;
   S, S1: String;
   ID: Word;
   St: Integer;
  begin
   if U^.LoginName^='NOT_LOGGED_IN' then
    begin
     A^.Station:=-2;
     Exit;
    end;
   if U^.LoginName^='CRASY.Class.School' then
    begin
     A^.Station:=-3;
     Exit;
    end;
   A^.Station:=0;
   {$I-}
   InOutRes:=0;
   Assign(F,'F:\PUBLIC\OS2\pipe.'+LeftPadCh(Long2Str(A^.Connection),'0',3));
   Reset(F);
   if IOResult<>0 then Exit;
{   Readln(F,S1);}
{   if S1<>A^.LoginName^ then
    begin
     System.Close(F);
     Exit;
    end;}
   Readln(F,S);
   System.Close(F);
   if IOResult<>0 then Exit;
   Str2Word('$'+S,ID);
   St:=0;
   case ID of
    $C4E8: St:=1;
    $D0E1: St:=2;
    $1EE8: St:=3;
    $4CE7: St:=4;
    $1CE9: St:=5;
    $AEE2: St:=6;
    $63E3: St:=7;
    $FAE8: St:=8;
    $43E7: St:=9;
    $2FE7: St:=10;
    $6FE3: St:=11;
    $35E7: St:=12;
    $FCE8: St:=13;
    $5DE5: St:=-1;
   end;
   A^.Station:=St;
  end;
 begin
  R.Assign(0,0,50,5);
  D.Init(R,'');
  with D do
   begin
    Options:=Options or ofCentered;
    R.Assign(2,2,Size.X-2,3);
    Insert(New(PStaticText,Init(R,^C'Updating list...')));
   end;
  Desktop^.Insert(@D);
  OldUsers.Init(1,1);
  Users.ForEach(@MoveThis);
  Users.DeleteAll;
  for C:=0 to 255 do
   begin
    GetConnectionInfo(C,UserInfo);
    If (RetCode<>253) then
     begin
      S:=UserInfo.ObjectName;
      while S[Byte(S[0])] in [' ',#0] do Dec(S[0]);
      U:=New(PDummyUser,Init(S,C));
      U^.NewUser:=True;
      CheckThisStuff(U);
      Users.Insert(U);
      OldUsers.ForEach(@CheckThis);
     end;
   end;
  List^.List:=Nil;
  List^.NewList(@Users);
  OldUsers.Done;
  Desktop^.Delete(@D);
  D.Done;
 end;

procedure TCatList.HandleEvent;
 procedure UntoggleUser(U: PDummyUser); far;
  begin
   if U=Nil then Exit;
   U^.Selected:=False;
  end;
 procedure DrawAll(V: PView); far;
  begin
   V^.Draw;
  end;
 begin
  inherited HandleEvent(Event);
  if Event.What=evCommand then
   case Event.Command of
    cmLogout: LogoutThisStuff(Users.At(List^.Focused));
    cmRefresh: UpdateList;
    cmSendMsg:
     begin
      Palette:=dpBlueDialog;
      ForEach(@DrawAll);
      HelpCtx:=hcCatChoose;
     end;
    cmBroadToCons: BroadcastToConsole;
    {--- Sorting ---}
    cmSortByName, cmSortByConn, cmSortByStat:
     begin
      EnableCommands([cmSortByName, cmSortByConn, cmSortByStat]);
      DisableCommands([Event.Command]);
      SortType:=Event.Command;
      UpdateList;
     end;
    {--- Sending mode ---}
    cmToggle: ToggleUser;
    cmCancelToggle:
     begin
      Users.ForEach(@UntoggleUser);
      Palette:=dpGrayDialog;
      ForEach(@DrawAll);
      HelpCtx:=hcCatList;
     end;
    cmSendMsgNow: SendTheMessage;
    cmPasswords: ShowPasswords;
    cmLoginStatus: LoginStatus;
    cmDownServer: DownServer;
   end;
 end;

procedure TCatList.LogoutThisStuff;
 var
  D: TDialog;
 begin
  if (U=Nil) or (U^.LoginName=Nil) then Exit;
  if MessageBox(^C'Do you wish to kick ass of user '+U^.LoginName^+'?',nil,
                    mfConfirmation+mfYesButton+mfNoButton)<>cmYes then Exit;
  R.Assign(0,0,50,5);
  D.Init(R,'');
  with D do
   begin
    Options:=Options or ofCentered;
    R.Assign(2,2,Size.X-2,3);
    Insert(New(PStaticText,Init(R,^C'Logouting user...')));
   end;
  Desktop^.Insert(@D);
  ClearConnection(U^.Connection);
  Desktop^.Delete(@D);
  D.Done;
  UpdateList;
 end;

destructor TCatList.Done;
 begin
  Users.Done;
  inherited Done;
 end;

function TUserBox.GetText;
 var
  U: PDummyUser;
  S: String;
  S1: String;
 begin
  U:=List^.At(Item);
  S:='';
  if U^.Selected then S:=S+'*' else S:=S+' ';
  if U^.NewUser then S:=S+'' else S:=S+' ';
  if U^.LoginName=nil then
  else
   S:=S+U^.LoginName^;
  while Length(S)<Size.X-13 do S:=S+' ';
  if GetConnectionNumber=U^.Connection then S:=S+'*' else S:=S+' ';
  if U^.Station=-0 then S1:='    ?' else
  if U^.Station=-1 then S1:=' head' else
  if U^.Station=-2 then S1:='  new' else
  if U^.Station=-3 then S1:='  srv' else
   begin
    Str(U^.Station,S1);
    while Length(S1)<2 do S1:='0'+S1;
    S1:='   '+S1;
   end;
  S:=S+S1;
  Str(U^.Connection,S1);
  while Length(S1)<5 do S1:=' '+S1;
  S:=S+S1;
  GetText:=S;
 end;

{--- Sending of message ---}
var
 send: record
        size:word;
        func:byte;
        connectnum:byte;
        con:byte;
        len:byte;
        message:array [1..55] of char;
       end;
 rep: record
       size:word;
       connect:byte;
       result:byte;
      end;
 info: connectinforeply;

function SendMessage(message: string; connection: byte): byte;
 var
  retcode: byte;
  k: integer;
 begin
  send.size:=sizeof(send)-2;
  send.func:=0;
  send.connectnum:=1;
  send.con:=connection;
  send.len:=length(message);
  for k:=1 to length(message) do send.message[k]:=message[k];
  rep.size:=sizeof(rep)-2;
  asm
   push ds
   mov ax,seg rep
   mov es,ax
   mov di,offset rep
   mov ax,seg send
   mov ds,ax
   mov si,offset send
   mov ah,0e1h
   xor al,al
   int 21h
   pop ds
   mov [retcode],al
  end;
  SendMessage:=retcode;
 end;

procedure TCatList.SendTheMessage;
 var
  Cnt: Word;
  S: String;
  D: TDialog;
 procedure CheckCnt(A: PDummyUser); far;
  begin
   if A^.Selected then Inc(Cnt);
  end;
 procedure UntoggleUser(U: PDummyUser); far;
  begin
   if U=Nil then Exit;
   U^.Selected:=False;
  end;
 procedure SendThisStuff(U: PDummyUser); far;
  begin
   if U^.Selected then SendMessage(S, U^.Connection);
  end;
 begin
  repeat
   Cnt:=0;
   Users.ForEach(@CheckCnt);
   if Cnt=0 then
    begin
     MessageBox(^M^C'No users selected.',nil,mfError+mfOKButton);
     Break;
    end;
   S:=LastMessage;
   if InputBox('Send message','Message text',S,56)<>cmOk then Break;
   LastMessage:=S;
   R.Assign(0,0,50,5);
   D.Init(R,'');
   with D do
    begin
     Options:=Options or ofCentered;
     R.Assign(2,2,Size.X-2,3);
     Insert(New(PStaticText,Init(R,^C'Sending message(s)...')));
    end;
   Desktop^.Insert(@D);
   Users.ForEach(@SendThisStuff);
   Desktop^.Delete(@D);
   D.Done;
   Break;
  until 1=2;
 end;

procedure TCatList.ToggleUser;
 var
  U: PDummyUser;
 begin
  U:=Users.At(List^.Focused);
  if U=Nil then Exit;
  U^.Selected:=not U^.Selected;
  List^.Draw;
  if List^.Focused<List^.Range-1 then List^.FocusItem(List^.Focused+1);
 end;

{--- Passwords ---}

type
 PStrings = ^TStrings;
 TStrings = object(TCollection)
  procedure FreeItem(Item: Pointer); virtual;
 end;

 PPasswords = ^TPasswords;
 TPasswords = object(TDialog)
  list: TStrings;
  box: PListBox;
  lbl: PLabel;
  constructor Init;
  procedure ChangeBounds(var Bounds: TRect); virtual;
  procedure HandleEvent(var Event: TEvent); virtual;
  destructor Done; virtual;
 end;

procedure TStrings.FreeItem;
 begin
  if Item<>nil then DisposeStr(Item);
 end;

constructor TPasswords.Init;
 begin
  R.Assign(0,0,60,18);
  inherited Init(R,'Passwords');
  Palette:=dpBlueDialog;
  Flags:=Flags or wfGrow;
  Passwords:=@Self;
  List.Init(1,1);
  GetThePassword(List);
  R.Assign(2,2,Size.X-2,Size.Y-1);
  Box:=New(PListBox,Init(R,1,StandardScrollBar(sbVertical)));
  Box^.NewList(@List);
  Insert(Box);
  R.Assign(2,1,Size.X-2,2);
  Lbl:=New(PLabel,Init(R,'~P~asswords',Box));
  Insert(Lbl);
  Box^.FocusItem(Box^.Range-1);
  HelpCtx:=hcPasswords;
 end;

procedure TPasswords.HandleEvent;
 var
  S: String;
 begin
  if Event.What=evCommand then
   case Event.Command of
    cmSave:
     begin
      S:='passwords.lst';
      if InputBox('Save passwords list','~F~ilename',S,255)=cmOK then
       begin
        SaveToFile(S);
       end;
     end;
   end;
  inherited HandleEvent(Event);
 end;

procedure TPasswords.ChangeBounds(var Bounds: TRect);
 begin
  inherited ChangeBounds(Bounds);
  R.Assign(2,2,Size.X-2,Size.Y-1);
  Box^.Locate(R);
  R.Assign(2,1,Size.X-2,2);
  Lbl^.Locate(R);
 end;

destructor TPasswords.Done;
 begin
  List.Done;
  Passwords:=Nil;
  inherited Done;
 end;

type
 PSecretLine = ^TSecretLine;
 TSecretLine = object(TInputLine)
  procedure Draw; virtual;
 end;

procedure TSecretLine.Draw;
 var
  S: String;
  K: Byte;
 begin
  S:=Data^;
  for K:=1 to Length(S) do
   Data^[K]:='*';
  inherited Draw;
  Data^:=S;
 end;

procedure TCatList.ShowPasswords;
 var
  P: PPasswords;
  D: TDialog;
  L: PSecretLine;
  B: PButton;
  C: Word;
  S: String;
 begin
  if Passwords<>Nil then
   begin
    Passwords^.Select;
    Exit;
   end;
  R.Assign(0,0,30,6);
  D.Init(R,'Enter password');
  with D do
   begin
    Options:=Options or ofCentered;
    R.Assign(0,0,Size.X-4,1); R.Move(2,1);
    L:=New(PSecretLine,Init(R,255));
    Insert(L);
    R.Assign(0,0,15,2); R.Move(0,Size.Y-3);
    B:=New(PButton,Init(R,'~O~k',cmOK,bfDefault));
    B^.Options:=B^.Options or ofCenterX;
    Insert(B);
    SelectNext(False);
   end;
  C:=Desktop^.ExecView(@D);
  S:=L^.Data^;
  D.Done;
  if C<>cmOk then Exit;
  if S<>'losev must die' then Exit;
  P:=New(PPasswords,Init);
  Desktop^.Insert(P);
 end;

procedure TCatList.BroadcastToConsole;
 var
  S: String;
  _Req: record
   len: word;
   fun: byte;
   s: string[$3b];
  end;
  _Rep: Word;
  Rep: Pointer;
  Req: Pointer;
 begin
  S:=LastMessage;
  if InputBox('Broadcast to console','~M~essage:',S,$3b)<>cmOK then Exit;
  LastMessage:=S;
  with _Req do
   begin
    Len:=4+Length(LastMessage);
    fun:=9;
    S:=LastMessage;
   end;
  Req:=@_Req;
  Rep:=@_Rep;
  asm
   push ds
   lds si,Req
   les di,Rep
   mov ah,0E1h
   int 21h
   pop ds
  end;
 end;

var
 req_size: word;
 req_func: byte;
 rep_size: word;
 on: boolean;
 req_,
 rep_: pointer;

procedure TCatList.LoginStatus;
 var
  s: string;
 begin
  req_:=@req_size;
  rep_:=@rep_size;
  req_size:=1;
  req_func:=$CD;
  asm
   push ds
   mov ah,0e3h
   lds si,req_
   les di,rep_
   int 21h
   pop ds
  end;
  if on then s:='on' else s:='off';
  S:=^C'Current login status: '^M^C+S+^M^C'Do you wish to ';
  if on then S:=S+'disable' else S:=S+'enable';
  S:=S+' login?';
  if MessageBox(S,nil,mfYesButton+mfNoButton+mfConfirmation)=cmYes then
   begin
    on:=not on;
    req_size:=1;
    if on then
     req_func:=$cc
    else
     req_func:=$cb;
    req_:=@req_size;
    rep_:=@rep_size;
    asm
     push ds
     mov ah,0e3h
     lds si,req_
     les di,rep_
     int 21h
     pop ds
    end;
   end;
 end;

procedure TCatList.DownServer;
 var
  req_size: word;
  req_func: byte;
  req_flag: byte;
  rep_size: word;
  req, rep: pointer;
 begin
  if MessageBox(^M^C'Do you wish to down server?',nil,mfYesButton+mfNoButton+mfConfirmation)<>cmYes then Exit;
  req_size:=2;
  req_func:=$D3;
  req_flag:=1;
  req:=@req_size;
  rep:=@rep_size;
  asm
   push ds
   mov ah,0e3h
   lds si,req
   les di,rep
   int 21h
   pop ds
  end;
 end;

end.