unit net;
 interface
  type
   nametype=array [1..48] of char;
   pserverinfopacket=^serverinfopacket;
   serverinfopacket=record
                     size:word;
                     name:array [1..48] of char;
                     netver,netsubver:byte;
                     maxconnect:word;
                     usedconnect:word;
                     maxvolumes:word;
                     revisionlevel:byte;
                     sftlevel:byte;
                     ttslevel:byte;
                     peakconnectused:word;
                     accountver:byte;
                     vapversion:byte;
                     queingver:byte;
                     prnserverver:byte;
                     virtualconver:byte;
                     secrestrictlevel:byte;
                     internetbridgesupport:byte;
                     something:array [1..60] of byte;
                    end;
   pemptysendpacket=^emptysendpacket;
   emptysendpacket=record
                    size:word;
                    func:byte;
                   end;
   pconnectinfosend=^connectinfosend;
   connectinfosend=record
                    size:word;
                    func:byte;
                    connectnumber:byte;
                   end;
   pconnectinforeply=^connectinforeply;
   connectinforeply=record
                     size:word;
                     objectid:longint;
                     objecttype:word;
                     objectname:nametype;
                     logintime:array [1..7] of byte;
                    end;
  var
   retcode:byte;
  function getlong(w:longint):longint;
  function getconnectionnumber:byte;
  procedure getconnectioninfo(connectionnumber:byte;var coninfo:connectinforeply);
  function getnetserialnumber:longint;
  procedure getserverinfo(var serverinfo:serverinfopacket);
  procedure ClearConnection(C: Byte);

 implementation
 uses dos;
  function getlong(w:longint):longint;
   type
    longtype=record
              case integer of
               1:(long:longint);
               2:(loword,hiword:word);
             end;
   var
    p:^longtype;
    l:longtype;
   begin
    getmem(p,4);
    p^.long:=w;
    l.loword:=swap(p^.hiword);
    l.hiword:=swap(p^.loword);
    freemem(p,4);
    getlong:=l.long;
   end;
  function getconnectionnumber:byte;assembler;
   asm
    mov ah,0dch
    int 21h
    xor ah,ah
   end;
  procedure getconnectioninfo;
   var
    snp:pconnectinfosend;
    rpp:pconnectinforeply;
   begin
    getmem(snp,sizeof(connectinfosend));
    getmem(rpp,sizeof(connectinforeply));
    snp^.size:=2;snp^.func:=$16;snp^.connectnumber:=connectionnumber;
    rpp^.size:=61;
    retcode:=0;
    asm
     push ds
     lds si,snp
     les di,rpp
     mov ah,0e3h
     int 21h
     pop ds
     mov [retcode],al
    end;
    rpp^.objectid:=getlong(rpp^.objectid);
    rpp^.objecttype:=swap(rpp^.objecttype);
    coninfo:=rpp^;
    freemem(snp,sizeof(connectinfosend));
    freemem(rpp,sizeof(connectinforeply));
   end;
  function getnetserialnumber:longint;
   type
    pservernumpacket=^servernumpacket;
    servernumpacket=record
                     size:word;
                     number:longint;
                     appnum:word;
                    end;
   var
    sendpacket:pemptysendpacket;
    replypacket:pservernumpacket;
   begin
    getmem(sendpacket,sizeof(emptysendpacket));
    getmem(replypacket,sizeof(servernumpacket));
    sendpacket^.size:=1;
    replypacket^.size:=6;
    sendpacket^.func:=$12;
    retcode:=0;
    asm
     push ds
     lds si,sendpacket
     les di,replypacket
     mov ah,0e3h
     int 21h
     pop ds
     mov [retcode],al
    end;
    getnetserialnumber:=getlong(replypacket^.number);
    freemem(sendpacket,sizeof(emptysendpacket));
    freemem(replypacket,sizeof(servernumpacket));
   end;
  procedure getserverinfo;
   var
    snp:pemptysendpacket;
    rpp:pserverinfopacket;
   begin
    getmem(snp,3);snp^.size:=1;snp^.func:=$11;
    getmem(rpp,sizeof(serverinfopacket));rpp^.size:=sizeof(serverinfopacket)-2;
    retcode:=0;
    asm
     push ds
     lds si,snp
     les di,rpp
     mov ah,0e3h
     int 21h
     pop ds
     mov [retcode],al
    end;
    rpp^.maxconnect:=swap(rpp^.maxconnect);
    rpp^.usedconnect:=swap(rpp^.usedconnect);
    rpp^.maxvolumes:=swap(rpp^.maxvolumes);
    rpp^.peakconnectused:=swap(rpp^.peakconnectused);
    serverinfo:=rpp^;
    freemem(snp,3);
    freemem(rpp,sizeof(serverinfopacket));
   end;

procedure ClearConnection(C: Byte);
 var
  _buf: record
         l: word;
         fun: byte;
         c: byte;
        end;
  buf: pointer;
  _r: word;
  r: pointer;
  reg: registers;
 begin
  buf:=@_buf;
  _buf.l:=2;
  _buf.fun:=$d2;
  _buf.c:=c;
  r:=@_r;
{  asm
   push ds
   mov ah,0e3h
   lds si,buf
   les di,r
   int 21h
   pop ds
  end;}
  with reg do
   begin
    ax:=$e3e3;
    ds:=seg(_buf);
    si:=ofs(_buf);
    es:=seg(_r);
    di:=ofs(_r);
    intr($21,reg);
   end;
 end;

 end.