unit Net2;
{ Some nice procedures for Novell Netware.
  Unit version 1.0alpha.
  (c) by WiZARD, 1997.

  (beta-tested on Novell Netware 4.11)
}
interface

type
 PTime          = ^TTime;
 TTime          = record
  year          : byte;
  month         : byte;
  day           : byte;
  hour          : byte;
  minute        : byte;
  second        : byte;
  dow           : byte;
 end;

 PFSStatistics  = ^TFSStatistics;
 TFSStatistics  = record
  size          : word;         {internal}
  ticks         : longint;      {ticks since server started}
  maxfiles      : word;         {maximum open files set by configuration}
  maxconcurr    : word;         {maximum files open concurrently}
  opened        : word;         {current number of open files}
  totalopened   : longint;      {total files opened}
  totalrr       : longint;      {total read requests}
  totalwr       : longint;      {total write requests}
  FATchcur      : word;         {current changed FATs}
  FATtotcur     : word;         {total changed FATs}
  FATwe         : word;         {FAT write errors number}
  FATfwe        : word;         {FAT fatal write errors number}
  FATse         : word;         {FAT scan errors}
  maxci         : word;         {maximum concurrently-indexed files}
  curif         : word;         {current number of indexed files}
  atif          : word;         {number of attached indexed files}
  ifavail       : word;         {number of indexed files available}
 end;

var
 time           : TTime;
const
 ErrorCode      : byte = 0;

procedure LogoutSelf;
{ same as LOGOUT command, logouts self connection }
function GetSelfConnection: byte;
{ return number of self connection }
function SendMessage(message: string; destination: byte): byte;
{ send a message to destination connection }
procedure SendMessageToServer(message: string);
{ send a message to server (displaying in main console screen) }
procedure GetConnectionInformation(connection: byte; var name: string);
{ if in 255th byte of string (name[255]) eq to #1, then
  this connection valid (user has been logged in at this connect)
  else (#0) this connection not used.}
procedure SetLoginStatus(AllowLogin: Boolean);
{ sets login status. if login not allowed (allowlogin=false) then
  new users cannot logon using LOGIN.EXE }
function GetLoginStatus: boolean;
{ return login status (see SetLoginStatus) }
procedure LogoutConnection(Connection: Byte);
{ and my favourite procedure - LogoutConnection.
  working only if you have supervisor rights }
procedure GetFSStatistics(var Stat: TFSStatistics);

implementation

procedure LogoutSelf; assembler;
 asm
  mov   ah,0D7h
  int   21h
  mov   ErrorCode,AL
 end;

function GetSelfConnection: byte; assembler;
 asm
  mov   ah,0DCh
  int   21h
 end;

function SendMessage(message: string; destination: byte): byte;
 var
  _Request: record
   len    : word;
   func   : byte;
   ctos   : byte;
   dest   : byte;
   mes    : string[60];
  end;
  _Reply  : record
   len    : word;
   sto    : byte;
   status : byte;
  end;
  Request : pointer;
  Reply   : pointer;
 begin
  Request:=@_Request;
  Reply:=@_Reply;
  with _Request do
   begin
    len:=SizeOf(_Request);
    func:=0;
    ctos:=1;
    dest:=destination;
    mes:=message;
   end;
  asm
   push   ds
   mov    ah,0E1h
   lds    si,Request
   les    di,Reply
   int    21h
   pop    ds
   mov    ErrorCode,al
  end;
  SendMessage:=_Reply.Status;
 end;

procedure SendMessageToServer(message: string);
 var
  _Request: record
   len    : word;
   func   : byte;
   mes    : string[60];
  end;
  _Reply  : word;
  Request : pointer;
  Reply   : pointer;
 begin
  Request:=@_Request;
  Reply:=@_Reply;
  with _Request do
   begin
    len:=SizeOf(_Request);
    func:=9;
    mes:=message;
   end;
  asm
   push   ds
   mov    ah,0E1h
   lds    si,Request
   les    di,Reply
   int    21h
   pop    ds
   mov    ErrorCode,al
  end;
 end;

procedure GetConnectionInformation(connection: byte; var name: string);
 var
  _Request: record
   len    : word;
   func   : byte;
   conn   : byte;
  end;
  _Reply  : record
   len    : word;
   obj    : longint;
   obj2   : word;
   name   : array[1..48] of char;
   time   : TTime;
  end;
  Request : pointer;
  Reply   : pointer;
  K       : byte;
 begin
  Request:=@_Request;
  Reply:=@_Reply;
  with _Request do
   begin
    len:=SizeOf(_Request);
    func:=$16;
    conn:=connection;
   end;
  asm
   push   ds
   mov    ah,0E3h
   lds    si,Request
   les    di,Reply
   int    21h
   pop    ds
   mov    ErrorCode,al
  end;
  Move(_Reply.name,name[1],SizeOf(_Reply.name));
  for k:=1 to 48 do
   if name[k]=#0 then break;
  name[0]:=Char(k-1);
  Time:=_Reply.Time;
  If ErrorCode=253 then name[255]:=#0 else name[255]:=#1;
 end;

procedure SetLoginStatus(AllowLogin: Boolean);
 var
  _Request: record
   len    : word;
   func   : byte;
  end;
  _Reply  : word;
  Request : pointer;
  Reply   : pointer;
 begin
  Request:=@_Request;
  Reply:=@_Reply;
  with _Request do
   begin
    len:=SizeOf(_Request);
    if AllowLogin then func:=$CC else func:=$CB;
   end;
  asm
   push   ds
   mov    ah,0E3h
   lds    si,Request
   les    di,Reply
   int    21h
   pop    ds
   mov    ErrorCode,al
  end;
 end;

function GetLoginStatus: boolean;
 var
  _Request: record
   len    : word;
   func   : byte;
  end;
  _Reply  : record
   len    : word;
   status : boolean;
  end;
  Request : pointer;
  Reply   : pointer;
 begin
  Request:=@_Request;
  Reply:=@_Reply;
  with _Request do
   begin
    len:=SizeOf(_Request);
    func:=$CD;
   end;
  asm
   push   ds
   mov    ah,0E3h
   lds    si,Request
   les    di,Reply
   int    21h
   pop    ds
   mov    ErrorCode,al
  end;
  GetLoginStatus:=_Reply.Status;
 end;

procedure LogoutConnection(Connection: Byte);
 var
  _Request: record
   len    : word;
   func   : byte;
   conn   : byte;
  end;
  _Reply  : word;
  Request : pointer;
  Reply   : pointer;
 begin
  Request:=@_Request;
  Reply:=@_Reply;
  with _Request do
   begin
    len:=SizeOf(_Request);
    func:=$D2;
    conn:=connection;
   end;
  asm
   push   ds
   mov    ah,0E3h
   lds    si,Request
   les    di,Reply
   int    21h
   pop    ds
   mov    ErrorCode,al
  end;
 end;

procedure GetFSStatistics(var Stat: TFSStatistics);
 var
  _Request: record
   len    : word;
   func   : byte;
  end;
  Request : pointer;
  Reply   : pointer;
 begin
  Request:=@_Request;
  Reply:=@Stat;
  with _Request do
   begin
    len:=SizeOf(_Request);
    func:=$D4;
   end;
  asm
   push   ds
   mov    ah,0E3h
   lds    si,Request
   les    di,Reply
   int    21h
   pop    ds
   mov    ErrorCode,al
  end;
 end;

end.